object solution {

def distance(a:Seq[(Double, Double)],b:Seq[(Double, Double)]) = Math.sqrt( Math.pow(a(0)._1-b(0)._1, 2) + Math.pow(a(0)._2-b(0)._2, 2) ) 

def main(args: Array[String]) {
val lines = sc.textFile("./random.10.data.txt")
val k = 8-1
	
//Creating the point objects
val points = lines.map(s => s.split(",")).map(arr => arr(0) -> (arr(1).toDouble,arr(2).toDouble)).distinct().groupByKey().cache()

// remove the (x,x) diagonal
val distanceBetweenPoints = points.cartesian(points).filter{case (a,b) => (a!=b)}.map{case (a,b) => ((a._1,b._1),distance(a._2.toSeq,b._2.toSeq))}

// create list for each user
val userLists=distanceBetweenPoints.groupBy(_._1._1)
val sortedUserLists=userLists.mapValues(iter => iter.toList.sortBy(_._2).take(k))
//Retrieve RDD contents as a local collection
val output = sortedUserLists.collect()
output.foreach(tup => println(tup._1 + "->" + tup._2.map(x=>x._1._2+","+ "%.3f".format(x._2)+" ").mkString))
spark.stop()
}
}
